# Generated by Django 4.2.1 on 2023-05-20 08:11

from django.db import migrations, models


def forwards_func(apps, schema_editor):
    db_alias = schema_editor.connection.alias
    Tracker = apps.get_model("manager", "Tracking")

    trackers = (
        Tracker.objects.using(db_alias)
        .filter(info__info__isnull=False)
        .iterator()
    )

    for _tracker in trackers:
        _tracker.info = {
            k: v for k, v in (_tracker.info or {}).items() if k != "info"
        }

        _tracker.save()


def reverse_func(apps, schema_editor):
    pass


class Migration(migrations.Migration):
    dependencies = [
        ("manager", "0051_auto_20230330_0556"),
    ]

    operations = [
        migrations.RunPython(forwards_func, reverse_func),
    ]
