# Generated by Django 4.2.10 on 2024-03-18 03:33

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import functools
import karrio.server.core.models.base
import karrio.server.core.utils


class Migration(migrations.Migration):

    dependencies = [
        ("providers", "0071_alter_tgesettings_my_toll_token"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("manager", "0057_alter_customs_invoice_date"),
    ]

    operations = [
        migrations.CreateModel(
            name="Manifest",
            fields=[
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "id",
                    models.CharField(
                        default=functools.partial(
                            karrio.server.core.models.base.uuid,
                            *(),
                            **{"prefix": "manf_"}
                        ),
                        editable=False,
                        max_length=50,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                (
                    "metadata",
                    models.JSONField(
                        blank=True,
                        default=functools.partial(
                            karrio.server.core.utils.identity, *(), **{"value": {}}
                        ),
                        null=True,
                    ),
                ),
                (
                    "meta",
                    models.JSONField(
                        blank=True,
                        default=functools.partial(
                            karrio.server.core.utils.identity, *(), **{"value": {}}
                        ),
                        null=True,
                    ),
                ),
                (
                    "options",
                    models.JSONField(
                        blank=True,
                        default=functools.partial(
                            karrio.server.core.utils.identity, *(), **{"value": {}}
                        ),
                        null=True,
                    ),
                ),
                (
                    "messages",
                    models.JSONField(
                        blank=True,
                        default=functools.partial(
                            karrio.server.core.utils.identity, *(), **{"value": []}
                        ),
                        null=True,
                    ),
                ),
                ("reference", models.CharField(blank=True, max_length=100, null=True)),
                ("manifest", models.TextField(blank=True, null=True)),
                ("test_mode", models.BooleanField()),
                (
                    "address",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="manifest",
                        to="manager.address",
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "manifest_carrier",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="providers.carrier",
                    ),
                ),
            ],
            options={
                "verbose_name": "Manifest",
                "verbose_name_plural": "Manifests",
                "db_table": "manifest",
                "ordering": ["-created_at"],
            },
            bases=(karrio.server.core.models.base.ControlledAccessModel, models.Model),
        ),
        migrations.AddField(
            model_name="shipment",
            name="manifest",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="shipments",
                to="manager.manifest",
            ),
        ),
    ]
